/** @file
    A simple, basic, application showing how the Hello application could be
    built using the "Standard C Libraries" from StdLib.

    Copyright (c) 2010 - 2011, Intel Corporation. All rights reserved.<BR>
    This program and the accompanying materials
    are licensed and made available under the terms and conditions of the BSD License
    which accompanies this distribution. The full text of the license may be found at
    http://opensource.org/licenses/bsd-license.

    THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
    WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
**/
#include <Library/BaseLib.h>
#include <Uefi.h>
#include <Library/UefiLib.h>
#include <Library/BaseMemoryLib.h>
#include <Library/MemoryAllocationLib.h>
#include <Protocol/LoadedImage.h>
#include <Protocol/DevicePath.h> //EFI_DEVICE_PATH_PROTOCOL
#include <Protocol/DevicePathToText.h> //EFI_DEVICE_PATH_TO_TEXT_PROTOCOL

extern EFI_BOOT_SERVICES         *gBS;

EFI_STATUS
EFIAPI
UefiMain (
  IN EFI_HANDLE        ImageHandle,
  IN EFI_SYSTEM_TABLE  *SystemTable
  )
{
        EFI_STATUS               Status;
        EFI_LOADED_IMAGE_PROTOCOL *ImageInfo = NULL;
        EFI_DEVICE_PATH_TO_TEXT_PROTOCOL *Device2TextProtocol;
        CHAR16  *TextDevicePath;
        UINTN           Index;
        CHAR8  *p;
        
        Status = gBS -> HandleProtocol(
                        ImageHandle,
                        &gEfiLoadedImageProtocolGuid,
                        &ImageInfo);
        if (EFI_ERROR(Status)) {
                Print(L"Error!\n");
        }

        //get a converter.
        Status = gBS->LocateProtocol(&gEfiDevicePathToTextProtocolGuid,
                                     NULL,
                                     (VOID**)&Device2TextProtocol
                                    );

        //convert device path to text.
        if (!EFI_ERROR (Status))
        {
                TextDevicePath= Device2TextProtocol->ConvertDevicePathToText(ImageInfo->FilePath, TRUE, FALSE);
                Print(L"%s\n",TextDevicePath);
                gBS->FreePool(TextDevicePath);
        }
        
        Print(L"Type:[%d] SubType:[%d] Length:[%d] \n",
                    ImageInfo->FilePath->Type,            
                    ImageInfo->FilePath->SubType,
                    ImageInfo->FilePath->Length[0]+
                    (ImageInfo->FilePath->Length[1]<<8));
        
        Print(L"%x\n",ImageInfo->FilePath);  
        p=(CHAR8 *)ImageInfo->FilePath;
        p=p+4;
        Print(L"%s\n",p);          
        for (Index=0;Index<ImageInfo->FilePath->Length[0]+(ImageInfo->FilePath->Length[1]<<8)-4;Index++) {
              Print(L"%2X ",*p);  
              p++;
        }
        Print(L"\n");  

        return 0;
}
